unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Objects, FMX.Layouts,
  FMX.TabControl, FMX.Advertising,
  uniGameClass;

type
  TForm1 = class(TForm)
    tbcMain: TTabControl;
    tbtmMain: TTabItem;
    tbtmBefore: TTabItem;
    lytBeforeSceneMain: TScaledLayout;
    imgCup1: TImage;
    imgCup2: TImage;
    imgCup3: TImage;
    imgCup4: TImage;
    lytMainSceneMain: TScaledLayout;
    rctngl1: TRectangle;
    grdpnlyt1: TGridPanelLayout;
    txt1: TText;
    rctnglGameStart: TRectangle;
    tbtmIntro: TTabItem;
    rctnglNone: TRectangle;
    rctnglMain: TRectangle;
    btnGameStart: TText;
    rctnglBefore: TRectangle;
    tmrGameLoop: TTimer;
    txtIntro: TText;
    txt4: TText;
    txt5: TText;
    txt6: TText;
    txt7: TText;
    btnCup1: TText;
    btnCup2: TText;
    btnCup3: TText;
    btnCup4: TText;
    imgBall: TImage;
    lytBeforeSceneList: TGridPanelLayout;
    rctnglCupRoll: TRectangle;
    btnCupRoll: TText;
    lytLevelNMsgList: TGridPanelLayout;
    txtGameLevel: TText;
    txtGameTopMessage: TText;
    rctnglGameEnd: TRectangle;
    btnGameEnd: TText;
    rctnglGameStop: TRectangle;
    btnGameStop: TText;
    grdpnlyt3: TGridPanelLayout;
    lytGameButtonList: TGridPanelLayout;
    btnGameContinue: TText;
    tbtmExit: TTabItem;
    rctnglExit: TRectangle;
    lytExitSceneMain: TScaledLayout;
    rctngl3: TRectangle;
    grdpnlyt2: TGridPanelLayout;
    txt2: TText;
    grdpnlyt4: TGridPanelLayout;
    rctngl4: TRectangle;
    btnExitOk: TText;
    rctngl5: TRectangle;
    btnExitCancel: TText;
    tbtmStop: TTabItem;
    rctnglStop: TRectangle;
    lytStopSceneMain: TScaledLayout;
    rctngl6: TRectangle;
    grdpnlyt5: TGridPanelLayout;
    txt3: TText;
    grdpnlyt6: TGridPanelLayout;
    rctnglStopOk: TRectangle;
    btnStopOk: TText;
    rctnglStopCancel: TRectangle;
    btnStopCancel: TText;
    procedure FormCreate(Sender: TObject);
    procedure btnGameStartClick(Sender: TObject);
    procedure tmrGameLoopTimer(Sender: TObject);
    procedure btnGameEndClick(Sender: TObject);
    procedure btnCupRollClick(Sender: TObject);
    procedure btnCup1Click(Sender: TObject);
    procedure btnCup2Click(Sender: TObject);
    procedure btnCup3Click(Sender: TObject);
    procedure btnCup4Click(Sender: TObject);
    procedure btnGameContinueClick(Sender: TObject);
    procedure btnExitOkClick(Sender: TObject);
    procedure btnExitCancelClick(Sender: TObject);
    procedure btnGameStopClick(Sender: TObject);
    procedure btnStopOkClick(Sender: TObject);
    procedure btnStopCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    imgCupList: array[0..3] of TImage;
    fScale: TPosition;

    MyGame: TGameClass;
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;

  tbcMain.ActiveTab := tbtmIntro;
  tbcMain.TabPosition := TTabPosition.None;

  MyGame := TGameClass.Create;
  MyGame.tbcMain := tbcMain;


  // Intro Scene
  MyGame.tbtmIntro  := tbtmIntro;
  MyGame.txtIntro   := txtIntro;
  // Main Scene
  MyGame.tbtmMain         := tbtmMain;
  MyGame.lytMainSceneMain := lytMainSceneMain;
  // MyGame.rctnglMain       := rctnglMain;
  MyGame.btnGameStart     := btnGameStart;
  MyGame.btnGameEnd       := btnGameEnd;

  // Before Scene
  MyGame.tbtmBefore         := tbtmBefore;
  MyGame.lytBeforeSceneMain := lytBeforeSceneMain;
  // MyGame.rctnglBefore       := rctnglBefore;
  MyGame.txtGameLevel       := txtGameLevel;
  MyGame.txtGameTopMessage  := txtGameTopMessage;

  MyGame.btnCupRoll       := btnCupRoll;
  MyGame.btnGameStop      := btnGameStop;
  MyGame.btnGameContinue  := btnGameContinue;

  MyGame.btnCup1 := btnCup1;
  MyGame.btnCup2 := btnCup2;
  MyGame.btnCup3 := btnCup3;
  MyGame.btnCup4 := btnCup4;

  MyGame.imgBall := imgBall;

  MyGame.oriCupList[0] := imgCup1;
  MyGame.oriCupList[1] := imgCup2;
  MyGame.oriCupList[2] := imgCup3;
  MyGame.oriCupList[3] := imgCup4;
  MyGame.oriCupList[0].Tag := 0;
  MyGame.oriCupList[1].Tag := 1;
  MyGame.oriCupList[2].Tag := 2;
  MyGame.oriCupList[3].Tag := 3;

  // Exit Scene
  MyGame.tbtmExit         := tbtmExit;
  MyGame.lytExitSceneMain := lytExitSceneMain;
  // MyGame.rctnglExit       := rctnglExit;
  MyGame.btnExitOk        := btnExitOk;
  MyGame.btnExitCancel    := btnExitCancel;

  // Stop Scene
  MyGame.tbtmStop         := tbtmStop;
  MyGame.lytStopSceneMain := lytStopSceneMain;
  // MyGame.rctnglStop       := rctnglStop;
  MyGame.btnStopOk        := btnStopOk;
  MyGame.btnStopCancel    := btnStopCancel;

  MyGame.InitGameScene;
  MyGame.bGameLoop := True;
  tmrGameLoop.Enabled := True;
end;

procedure TForm1.btnGameStartClick(Sender: TObject);
begin
  MyGame.GameStartPress;
end;

procedure TForm1.btnGameEndClick(Sender: TObject);
begin
  MyGame.GameEndPress;
end;

procedure TForm1.btnCupRollClick(Sender: TObject);
begin
  MyGame.CupRollPress;
end;

procedure TForm1.btnGameStopClick(Sender: TObject);
begin
  MyGame.GameStopPress;
end;

procedure TForm1.btnCup1Click(Sender: TObject);
begin
  MyGame.CupNum1Press;
end;

procedure TForm1.btnCup2Click(Sender: TObject);
begin
  MyGame.CupNum2Press;
end;

procedure TForm1.btnCup3Click(Sender: TObject);
begin
  MyGame.CupNum3Press;
end;

procedure TForm1.btnCup4Click(Sender: TObject);
begin
  MyGame.CupNum4Press;
end;

procedure TForm1.btnGameContinueClick(Sender: TObject);
begin
  MyGame.GameContinuePress;
end;

procedure TForm1.btnExitOkClick(Sender: TObject);
begin
  MyGame.ExitOkPress;
end;

procedure TForm1.btnExitCancelClick(Sender: TObject);
begin
  MyGame.ExitCancelPress;
end;

procedure TForm1.btnStopOkClick(Sender: TObject);
begin
  MyGame.StopOkPress;
end;

procedure TForm1.btnStopCancelClick(Sender: TObject);
begin
  MyGame.StopCancelPress;
end;

procedure TForm1.tmrGameLoopTimer(Sender: TObject);
var
  fResult: Single;
begin
  tmrGameLoop.Enabled := False;
  if MyGame.WorkProcess = 1 then
  begin
    Close;
  end
  else
  begin
    tmrGameLoop.Enabled := True;
  end;
end;

end.
